#include <tap.h>
#include "libFireBird.h"

TAP_ID( 0x8100fedd );
#define TAPNAME "USB Reset"
TAP_PROGRAM_NAME(TAPNAME);
TAP_AUTHOR_NAME("R2-D2");
TAP_DESCRIPTION("Resets the USB system to recover from hangs");
TAP_ETCINFO(__DATE__);

dword TAP_EventHandler( word event, dword param1, dword param2 )
{
	return param1;
}

/*****************************************************************************/
/* TAP_main */
/*****************************************************************************/

int TAP_Main(void)
{
	dword fwInit = 0, fwTerm = 0;
	InitTAPex();
	fwInit = FindInstructionSequence(
		"8f8e83a0 11c00009 00000000 8F9983A0 8F390004 13200005 00000000 8F9983A0 8F390004 0320F809 00000000",
		"FFFF0000 FFFFFFFF FFFFFFFF FFFF0000 FFFFFFFF FFFFFFFF FFFFFFFF FFFF0000 FFFFFFFF FFFFFFFF FFFFFFFF",
		0x80080000, 0x80100000, 0, TRUE);
	fwTerm = FindInstructionSequence(
		"8f9983a0 13200009 00000000 8f9983a0 8f390014 13200005 00000000 8f9983a0 8f390014 0320f809 00000000",
		"FFFF0000 FFFFFFFF FFFFFFFF FFFF0000 FFFFFFFF FFFFFFFF FFFFFFFF FFFF0000 FFFFFFFF FFFFFFFF FFFFFFFF",
		0x80080000, 0x80100000, 0, TRUE);
	if(fwInit == 0 || fwTerm == 0)
	{
		TAP_Print("Unsupported firmware %d:%x\n",SysID,ApplID);
	}
	else
	{
		TAP_Print("Terminating %p\n",fwTerm);
		CallFirmwareA(fwTerm);
		TAP_Print("Initialising %p\n",fwInit);
		CallFirmwareA(fwInit);
	}
	return 0;
}
